/****************************************************************************
*  This file is part of the sam3 port for the TNKernel RTOS
*
*  Copyright (c) 2009 by Michael Fischer. All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*  
*  1. Redistributions of source code must retain the above copyright 
*     notice, this list of conditions and the following disclaimer.
*  2. Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the 
*     documentation and/or other materials provided with the distribution.
*  3. Neither the name of the author nor the names of its contributors may 
*     be used to endorse or promote products derived from this software 
*     without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
*  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
*  SUCH DAMAGE.
*
****************************************************************************
*  History:
*
*  26.09.2009  mifi   First Version
****************************************************************************/
#if defined(TN_ARCH_CM3) && defined(TN_PORT_SAM3)

/*=========================================================================*/
/*  Includes                                                               */
/*=========================================================================*/
#include "tn.h"

/*=========================================================================*/
/*  DEFINE: All Structures and Common Constants                            */
/*=========================================================================*/
typedef void (*IRQ_FUNC)(void);

extern IRQ_FUNC IRQTable[];

/*=========================================================================*/
/*  DEFINE: Definition of all public Data                                  */
/*=========================================================================*/

/*=========================================================================*/
/*  DEFINE: Definition of all local Data                                   */
/*=========================================================================*/

/*=========================================================================*/
/*  DEFINE: Definition of all local Procedures                             */
/*=========================================================================*/

/*=========================================================================*/
/*  DEFINE: All code exported                                              */
/*=========================================================================*/

/***************************************************************************/
/*  xxx_IrqHandler                                                         */
/*                                                                         */
/*  The handler here will be used to jump to user handler                  */
/*  installed by tn_irq_install()                                          */
/*                                                                         */
/*  In    : none                                                           */
/*  Out   : none                                                           */
/*  Return: none                                                           */
/***************************************************************************/

void SUPC_IrqHandler (void)
{
   IRQTable[SUPC_IrqHandler_ID]();
   tn_int_exit();
}

void RSTC_IrqHandler (void)
{
   IRQTable[RSTC_IrqHandler_ID]();
   tn_int_exit();
}

void RTC_IrqHandler (void)
{
   IRQTable[RTC_IrqHandler_ID]();
   tn_int_exit();
}

void RTT_IrqHandler (void)
{
   IRQTable[RTT_IrqHandler_ID]();
   tn_int_exit();
}

void WDT_IrqHandler (void)
{
   IRQTable[WDT_IrqHandler_ID]();
   tn_int_exit();
}

void PMC_IrqHandler (void)
{
   IRQTable[PMC_IrqHandler_ID]();
   tn_int_exit();
}

void EFC0_IrqHandler (void)
{
   IRQTable[EFC0_IrqHandler_ID]();
   tn_int_exit();
}

void EFC1_IrqHandler (void)
{
   IRQTable[EFC1_IrqHandler_ID]();
   tn_int_exit();
}

void DBGU_IrqHandler (void)
{
   IRQTable[DBGU_IrqHandler_ID]();
   tn_int_exit();
}

void HSMC4_IrqHandler (void)
{
   IRQTable[HSMC4_IrqHandler_ID]();
   tn_int_exit();
}

void PIOA_IrqHandler (void)
{
   IRQTable[PIOA_IrqHandler_ID]();
   tn_int_exit();
}

void PIOB_IrqHandler (void)
{
   IRQTable[PIOB_IrqHandler_ID]();
   tn_int_exit();
}

void PIOC_IrqHandler (void)
{
   IRQTable[PIOC_IrqHandler_ID]();
   tn_int_exit();
}

void USART0_IrqHandler (void)
{
   IRQTable[USART0_IrqHandler_ID]();
   tn_int_exit();
}

void USART1_IrqHandler (void)
{
   IRQTable[USART1_IrqHandler_ID]();
   tn_int_exit();
}

void USART2_IrqHandler (void)
{
   IRQTable[USART2_IrqHandler_ID]();
   tn_int_exit();
}

void USART3_IrqHandler (void)
{
   IRQTable[USART3_IrqHandler_ID]();
   tn_int_exit();
}

void MCI0_IrqHandler (void)
{
   IRQTable[MCI0_IrqHandler_ID]();
   tn_int_exit();
}

void TWI0_IrqHandler (void)
{
   IRQTable[TWI0_IrqHandler_ID]();
   tn_int_exit();
}

void TWI1_IrqHandler (void)
{
   IRQTable[TWI1_IrqHandler_ID]();
   tn_int_exit();
}

void SPI0_IrqHandler (void)
{
   IRQTable[SPI0_IrqHandler_ID]();
   tn_int_exit();
}

void SSC0_IrqHandler (void)
{
   IRQTable[SSC0_IrqHandler_ID]();
   tn_int_exit();
}

void TC0_IrqHandler (void)
{
   IRQTable[TC0_IrqHandler_ID]();
   tn_int_exit();
}

void TC1_IrqHandler (void)
{
   IRQTable[TC1_IrqHandler_ID]();
   tn_int_exit();
}

void TC2_IrqHandler (void)
{
   IRQTable[TC2_IrqHandler_ID]();
   tn_int_exit();
}

void PWM_IrqHandler (void)
{
   IRQTable[PWM_IrqHandler_ID]();
   tn_int_exit();
}

void ADCC0_IrqHandler (void)
{
   IRQTable[ADCC0_IrqHandler_ID]();
   tn_int_exit();
}

void ADCC1_IrqHandler (void)
{
   IRQTable[ADCC1_IrqHandler_ID]();
   tn_int_exit();
}

void HDMA_IrqHandler (void)
{
   IRQTable[HDMA_IrqHandler_ID]();
   tn_int_exit();
}

void UDPD_IrqHandler (void)
{
   IRQTable[UDPD_IrqHandler_ID]();
   tn_int_exit();
}

#endif /* TN_ARCH_CM3 && TN_PORT_SAM3 */
/*** EOF ***/
