/****************************************************************************
*  This file is part of the sam7 port for the TNKernel RTOS
*
*  Copyright (c) 2009 by Michael Fischer. All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*  
*  1. Redistributions of source code must retain the above copyright 
*     notice, this list of conditions and the following disclaimer.
*  2. Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the 
*     documentation and/or other materials provided with the distribution.
*  3. Neither the name of the author nor the names of its contributors may 
*     be used to endorse or promote products derived from this software 
*     without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
*  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
*  SUCH DAMAGE.
*
*****************************************************************************
*  History:
*
*  19.09.2009  mifi   First Version
****************************************************************************/
#if !defined(__TN_PORT_SAM7_H__) && defined(TN_ARCH_ARM) && defined(TN_PORT_SAM7)
#define __TN_PORT_SAM7_H__

/***************************************************************************/
/*  DEFINE: All Structures and Commn Constants                             */
/***************************************************************************/

/*
 * Define the irq id and prio type, this makes it easier
 * if it must changed e.g. from unsigned char to unsigned short.
 */
typedef unsigned char   TN_IRQ_ID;
typedef unsigned char   TN_IRQ_PRIO;

/*
 * The sam7 suports 32 irq's with 8 priority levels.
 */
#define TN_MAX_IRQ_ID   32

/* 8 Levels but combined with SRCTYPE, therefore 128 */
#define TN_MAX_IRQ_PRIO 128

/***************************************************************************/
/*                 P R O T O T Y P E S                                     */
/***************************************************************************/
void tn_irq_init (void);
int tn_irq_install (TN_IRQ_ID   id,
                    TN_IRQ_PRIO prio,
                    void (*irq_func)(void));

#endif /* !__TN_PORT_SAM7_H__ && TN_ARCH_ARM && TN_PORT_SAM7 */
/*** EOF ***/
